epgd.pages.records = {
    render: function () {
        if (!(epgd.login.rights & epgd.rights.umRecordings) == epgd.rights.umRecordings) return epgd.utils.popup(epgd.tr.error.forbidden, { title: epgd.tr.error.error });
        $('#menu_records').addClass("menu-active");
        var tr = epgd.tr.pages.records;
        epgd.$con.html('<div class="ui-widget"><div class="ui-state-highlight ui-corner-all" style="padding: 0.3em 0.7em; font-size:0.9em">'
                    + '<button class="iAsButton i-refresh" onclick="epgd.pages.records.update()">' + epgd.tr.reload + '</button> '
                    + '<span class="i-info-circled"></span><input type="checkbox" id="dragdrop"' + ($.support.touch ? '' : ' checked="checked"') + ' onchange="epgd.pages.records.dd(this.checked)" /> '
                    + tr.headline
                    + '</div></div><div id="records"></div>');
        epgd.utils.loader.process(function () {
            epgd.ajax({ url: epgd.login.url + "data/recordings", cache: false }, function (data) {
                var recs = data.recordings,
                    rec, key, paths, t, p, i,
                    tree = { f: {}, r: [] },
                    vdrs = {},
                    vdr, v,
                    html = '',
                    min = ' ' + epgd.tr.minutes,
                    $menu, $divs;

                for (vdr in epgd.vdrs.list) {
                    v = epgd.vdrs.list[vdr];
                    if (!v.usecommonrecfolder)
                        vdrs[vdr] = { f: {}, r: [] };
                    html += '<div>VDR - ' + v.name + ': ' + v.videodir + ' - ' + parseInt(v.videofree / 1000, 10) + ' GB ' + tr.available + ' / ' + parseInt(v.videototal / 1000, 10) + ' GB</div>';
                }
                if (!epgd.$con.find('#dragdrop').parent().append(html).length)
                    return false;
                html = '';

                for (i in recs) {
                    rec = recs[i];
                    t = vdrs[rec.vdruuid] || tree;
                    paths = rec.path.split('/');
                    paths.pop();
                    for (p = 0; p < paths.length; p++) {
                        key = paths[p].replace(/_/g, ' ');
                        t = t.f[key] || (t.f[key] = { f: {}, r: [] });
                    }
                    t.r.push(rec);
                }

                function checkTree(t) {
                    var hasContent = false,
                        subFolder, subTree;
                    t.cnt = 0;
                    for (subFolder in t.f) {
                        subTree = t.f[subFolder];
                        if (subTree.r.length == 1)
                            t.r.push(subTree.r.pop());
                         checkTree(subTree);
                         if (checkTree(subTree)) {
                             hasContent = true;
                             t.cnt += subTree.cnt;
                         } else
                             delete t.f[subFolder];
                    }
                    if (!hasContent)
                        delete t.f;
                    t.cnt += t.r.length;
                    return hasContent || t.r.length > 0;
                }
                function renderTree(t) {
                    Object.keys(t.f).sort().forEach(function (subFolder) {
                        var subTree = t.f[subFolder],
                            tit, i;
                        html += subFolder ? '<div class="folder"><h4><span class="i-folder-closed">(' + (subTree.cnt) + ')</span><m class="i-"/>' + subFolder + '</h4>' : '<div>';
                        subTree.f && renderTree(subTree);
                        if (subTree.r.length) {
                            subTree.r.sort(function (a, b) { return a.title > b.title ? 1 : -1 });
                            for (i in subTree.r) {
                                rec = subTree.r[i];
                                tit = (rec.name != subFolder ? rec.name : '')
                                  + (subFolder != rec.title && (rec.title != rec.name) ? '<br />' + rec.title : '')
                                  + (rec.shorttext && (rec.shorttext != rec.name) ? '<i>' + rec.shorttext + '</i>' : '');

                                html += '<div class="rec" data-start="' + rec.starttime + '" data-owner="' + (rec.owner || '')
                                  + '" data-md5="' + rec.md5path + '" data-path="' + rec.path + '">'
                                  + '<em>' + epgd.utils.formatDateTime(rec.starttime) + '</em><u>' + parseInt(rec.duration / 60, 10) + min + '</u><b>'
                                  + (tit || subFolder)
                                  + '</b></div>'
                            };
                        }
                        html += '</div>';
                    });
                }

                p = {};
                if (checkTree(tree))
                    p[tr.commonRecFolder] = tree;
                for (vdr in vdrs) {
                    t = vdrs[vdr];
                    if (checkTree(t)) {
                        p['VDR - ' + epgd.vdrs.list[vdr].name] = t;
                    }
                }
                renderTree({ f: p });

                $divs = epgd.$con.find('#records').html(html);
                if (!$divs.length)
                    return false;
                $divs = $divs.html(html).click(function (ev) {
                    var elem = ev.target;
                    if (elem.nodeName == 'M') {
                        $menu.show().position({
                            my: "left top",
                            at: "left bottom",
                            of: elem
                        });
                        $(document).one('click.recmenu', function (ev) {
                            if (ev.target.nodeName == 'A') {
                                var t = ev.target.parentNode.getAttribute('data-type');
                                t && epgd.pages.records.sort(elem.parentNode.parentNode, 'data-' + t, ev.target.className.indexOf('i-sort-name-up') >= 0 ? 1 : -1);
                            }
                            $menu.hide();
                            $(document).unbind('.recmenu');
                        }).bind("keyup.recmenu", function (e) {
                            if (e.keyCode == 27)
                                $(document).trigger("click.recmenu");
                        });
                        return false;
                    }

                    if (elem.nodeName == 'I' || elem.nodeName == 'SPAN')
                        elem = elem.parentNode;
                    if (elem.nodeName == 'B') {
                        elem = elem.parentNode;
                        if (!elem.recDetail)
                            elem.recDetail = new epgd.recordDetail(elem);
                        epgd.utils.loader.process(function () {
                            elem.recDetail.render();
                        });
                    } else if (elem.nodeName == 'H4') {
                        elem = elem.parentNode;
                        if (elem.nodeName == 'DIV' && elem.className.indexOf('folder') >= 0) {
                            if (elem.className.indexOf('open') == -1) {
                                if ($(window).width() < 500) {
                                    $(elem).siblings('.open').removeClass('open');
                                    document.body.scrollTop = $(elem).offset().top - 35;
                                }
                                $(elem).addClass('open');

                            } else
                                $(elem).removeClass('open');
                        }
                    }
                }).find('>div');
                if ($divs.length == 1)
                    $divs.first().toggleClass('open');
                $menu = $('<ul class="ui-menu ui-widget ui-widget-content" style="position:absolute">'
                    + '<li class="ui-menu-item" data-type="title"><a class="iAsButton i-sort-name-up"></a>&nbsp;<a class="iAsButton i-sort-name-down"></a>&nbsp;' + epgd.tr.pages.eventDetail.title + '</li>'
                    + '<li class="ui-menu-item" data-type="path"><a class="iAsButton i-sort-name-up"></a>&nbsp;<a class="iAsButton i-sort-name-down"></a>&nbsp;' + epgd.tr.pages.timerList.folder + '</li>'
                    + '<li class="ui-menu-item" data-type="start"><a class="iAsButton i-sort-name-up"></a>&nbsp;<a class="iAsButton i-sort-name-down"></a>&nbsp;' + epgd.tr.pages.timerList.recordTime + '</li>'
                    + '</ul>').hide().appendTo(epgd.$con);
                epgd.$con.find('#dragdrop').change();
                epgd.utils.loader.close();
            });
        },true);
    },
    dd: function (enable) {
        var $sortFolder = epgd.$con.find('#records .ui-sortable');
        if (enable && $sortFolder.length == 0) {
            epgd.$con.find('#records').find('>div').each(function () {
                var $vdr = $(this),
                    $folder = $vdr.add('.folder'),
                    folder = null;
                $folder.sortable({
                    items: ">.rec",
                    cancle: "b",
                    placeholder: "ui-state-highlight",
                    connectWith: $folder,
                    tolerance: "pointer",
                    forcePlaceholderSize: true,
                    cursorAt: { left: -15 },

                    start: function (ev, ui) {
                        $vdr.bind("mouseover.dd,touchend.dd", function (ev) {
                            folder = ev.relatedTarget;
                            if (folder && folder.nodeName == "H4") {
                                folder = folder.parentNode;
                                folder.className.indexOf('open') == -1 && window.setTimeout(function (curFolder) { if (folder == curFolder) curFolder.className += ' open'; }, 500, folder);
                            }
                        });
                        $trash = $('<button style="margin:-1px -30px" class="iAsButton i-trash" title="' + epgd.tr.del + '"/>').appendTo(ui.placeholder).mouseup(function (ev) {
                            $folder.sortable("cancel");
                            window.setTimeout(function () { epgd.pages.records.del(ui.item.context); }, 300);
                            return false;
                        });
                        $(document).bind("keyup.dd", function (e) {
                            if (e.keyCode == 27)
                                $folder.sortable("cancel");
                        });
                    },
                    beforeStop: function (ev, ui) {
                        $(document).unbind(".dd");
                        $trash.remove();
                    },
                    remove: function (ev, ui) {
                        var n = $(ui.item.context),
                            path = '';
                        while ((n = n.prevAll('h4')).length) { path = n.text() + '/' + path; n = n.parent() };
                        if (!epgd.pages.records.move(ui.item.context, path.slice(path.indexOf('/', 2) + 1).replace(/ /g, '_')))
                            $(this).sortable("cancel");
                    }
                });
            });
        } else
            $sortFolder.sortable(enable ? "enable" : "disable");
    },
    update: function(){
        epgd.ajax({ url: epgd.login.url + "data/updaterecordings" }, function (data) {
            epgd.utils.topInfo(epgd.tr.pages.records.refreshMessage.replace('$sec$', 5), { autoClose: 5000 });
            window.setTimeout(epgd.pages.records.render, 5000);
        });
    },
    move: function (elem, path) {
        var paths = elem.getAttribute('data-path').split('/');
        paths.pop();
        path = window.prompt(epgd.tr.pages.records.moveMessage.replace("$src$", paths.join('/')), path + paths.slice(-1));
        if (path) {
            epgd.ajax({ url: epgd.login.url + 'data/renamerecording?starttime=' + elem.getAttribute('data-start') + '&md5path=' + elem.getAttribute('data-md5') + '&owner=' + elem.getAttribute('data-owner') + '&name=' + path.replace(/\//g, '~'), async: true }, function (data) {
                data = data.result;
                if (data && data.state == 200)
                    epgd.utils.topInfo(epgd.tr.dataSaved);
                else{
                    epgd.utils.topInfo(data.message, { isError: 1 });
                    return false;
                }
            });
        }
        return !!path;
    },
    del: function (elem, path) {
        var doDel = window.confirm(epgd.tr.pages.records.deleteMessage.replace("$src$", elem.getAttribute('data-path')));
        if (doDel) {
            doDel = false;
            epgd.ajax({ url: epgd.login.url + 'data/deleterecording?starttime=' + elem.getAttribute('data-start') + '&md5path=' + elem.getAttribute('data-md5') + '&owner=' + elem.getAttribute('data-owner'), async: false }, function (data) {
                data = data.result;
                if (data && data.state == 200) {
                    epgd.utils.topInfo(epgd.tr.dataSaved);
                    $(elem).remove();
                    doDel= true;
                } else
                    epgd.utils.topInfo(data.message, { isError: 1 });
            });
        }
        return doDel;
    },
    sort: function (con, t, dir) {
        var $elems = $(con).find('>div.rec');
        if (t == 'data-title') 
            $elems.sort(function (a, b) { return a.firstChild.nextSibling.innerHTML > b.firstChild.nextSibling.innerHTML ? dir : -dir }).appendTo(con);
        else 
            $elems.sort(function (a, b) { return a.getAttribute(t) > b.getAttribute(t) ? dir : -dir }).appendTo(con);
        $(con).find('>div.folder').each(function () {
            epgd.pages.records.sort(this, t, dir);
        });
    }
};
